
//#include "Parser.h"
#include <string.h>
#include <iostream.h>
#include <stdio.h>

#include "Sender.h"

class Parser {

    public:

    Parser(Sender s): sender(s) {
      ch=0;bufSize=1024; // minimum 10
	buf=new char[bufSize];
	reserved=10;// the first 2 bytes are reserved for len, 8 bytes are reserved for a timestamp
	pos=reserved; 
	timeStamp=new int[2];

    }

    void parse() {
	while(cin.peek()!=EOF) {
	    parsePacket();
	}
    }
    private:
    int reserved;
      int *timeStamp;


    char* buf;
    int bufSize;
    int pos;

    Sender sender;
    char ch;

    void parsePacket() {
       parseTimeStamp();
       skipToNextLine();
       readDataLines();
       sendPacket();
    }

    void parseTimeStamp() {
      // parses a value like 956064787.510557 into 8 bytes
      timeStamp[0]=0;
      timeStamp[1]=0;
      short i=0;
	cin.get(ch);
	//cout << "\nTimestamp: ";
	while (i<2){
	  if(isNumber(ch)) {
	    timeStamp[i]*=10;
	    timeStamp[i]+=ch-48;
	  } else i++;
	  cin.get(ch);
	} 
	//cout << timeStamp[0] << '.' << timeStamp[1]<< '\n';
    }
 
    int isNumber(char c) {
	if ((c>47) && (c<58)) return 1;
	return 0;
    }

    int isHexDigit(char c) {
	// a-f
	if ((c>96) && (c<103)) return 1;
	return 0;
    }

    int isWhiteSpace(char c) {
	if (c==' ') return 1;
	if (c=='\n') return 1;
	if (c=='\t') return 1;
	return 0;
    }

    void skipToNextLine(){
	cin.get(ch);
	while (ch != '\n'){
	    cin.get(ch);
	} 
    }; 


   void skipWhiteSpace(){ // with pushback
       cin.get(ch);
       while (isWhiteSpace(ch)){
	   cin.get(ch);
       } 
       cin.putback(ch);
   }; 

    void readDataLines() {
	int pe;
	while (1) {
	    pe=cin.peek();
	    if(pe=='\t') readDataLine(); 
	    if (isNumber(pe)) return; // next packet's timestamp
	    if(pe==EOF) return;
	}
    }

    void readDataLine() {
	skipWhiteSpace();
	readNrs();
    }

    void readNrs() {
	int pe;
	while (1) {
	    readByte();
	    pe=cin.peek();
	    if(pe=='\n') {  // only one pair of hex digits.
		cin.get(ch);
		return;
	    }
	    if (pe==EOF) return; // ev. not necessary
	    readByte();
	    if(!cin.get(ch)) return;
	    if(ch=='\n') return;
	}
    }
    
    void readByte() { // reads 2 hex chars
	char b1,b2;
	cin.get(b1);
	cin.get(b2);
	//cout << ' ' << (int) calcByteVal(b1,b2);
	appendToBuf(calcByteVal(b1,b2));
    }
    

    char calcByteVal(char high, char low) {
	char ret=hexToVal(high);
	ret <<= 4;
	return ret+hexToVal(low);
    }

    char hexToVal(char hex) {
	if (isNumber(hex))
	    return hex-48;
	if (isHexDigit(hex))
	    return hex-87;
	cerr << "No hex digit: " << hex;
	return 0;
    }

    void appendToBuf(char b) {
	buf[pos]=b;
	pos++;
	if(pos==bufSize) {
	    // expand buffer
	    char* nBuf=new char[bufSize<<1];
	    for(int i=0;i<bufSize;i++)  // copy
		nBuf[i]=buf[i];
	    buf=nBuf;
	    bufSize=bufSize<<1;
	}
    }

    void setReservedBytes() {
	// the com protocol, also including the timestamp
	if(pos>65535+reserved) cerr<<"Too many bytes read in parser!";
	buf[0]=(char) ((pos-reserved)/256);
	buf[1]=(char) ((pos-reserved)%256);
	fillInHalfTimeStamp(0,2);
	fillInHalfTimeStamp(1,6);
    }

  void fillInHalfTimeStamp(short ti, short mi) {
    short up=mi+3;
    for(int i=up;i>=mi;i--) {
      buf[i]=(char) (timeStamp[ti]%256);
      timeStamp[ti]>>=8;
      //cout<< ' ' << buf[i];
    }

  }


    void sendPacket() {
	setReservedBytes();
	//cerr<< "\nSending " << pos<< " bytes";
	sender.forward(buf,pos);
	pos=reserved;
    }

};
